@echo off
set quality=90
set formats=*.png *.bmp
set magicPath=c:\Program Files\ImageMagick-7.1.1-Q16-HDRI
set magicExe=magick.exe

if not exist "%magicPath%\%magicExe%" (
  echo ERROR. Coudn't find ImageMagic path. Make sure you have it installed.
  echo Also, make sure you properly set up magicPath variable in this script.
  pause >NUL
  goto :eof
)

set "path=%magicPath%;%PATH%"
where %magicExe%
if %errorlevel% neq 0 (
  echo ERROR. Failed to set up PATH variable to search for ImageMagic.
  pause >NUL
  goto :eof
)

echo.
call :conv "%~1"
for /f "delims=" %%a in ('dir /b /s /ad "%~1\*"') do call :conv "%%~a"

echo.
echo Press ENTER to delete original files.
echo.
pause

call :remove "%~1"
for /f "delims=" %%a in ('dir /b /s /ad "%~1\*"') do call :remove "%%~a"

goto :eof

:conv
  pushd "%~1" || exit /b
  echo Working with: "%~1"
  call :find_avail_formats avail_fmt
  if "%avail_fmt%" neq "" %magicExe% mogrify -path ./ -format jpg -quality %quality% -regard-warnings -define jpeg:preserve-timestamps=true %avail_fmt%
  popd
exit /b

:find_avail_formats
  set "exts="
  set fmtlist=%formats%
  :find_loop
  for /F "tokens=1* delims= " %%a in ("%fmtlist%") do (
    if exist %%a (
	  set exts=%exts% %%a
	  for /F %%z in ('dir /b /a-d %%a ^| find /c /v ""') do echo 	Count %%a: %%z
	)
    set fmtlist=%%b
	if "%%b" neq "" goto find_loop
  )
  set %~1=%exts%
exit /b

:remove
  pushd "%~1" || exit /b
  
  del /f /q /a %formats%
  
  :: ImageMagick creates .jpg~ .jpg~~ etc when same target file name found
  if exist "*.jpg~*" (
    echo.
	echo WARNING: Backup files *.jpg~ found.
	echo Press ENTER if you want to delete them too.
	echo.
	pause
	del /f /q /a *.jpg~*
  )
  popd
exit /b
